## starpu-contrib 1.4.5+dfsg

=== debian/changelog ===
starpu-contrib (1.4.5+dfsg-2build2) plucky; urgency=medium

  * No-change rebuild for openmpi soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 01 Dec 2024 21:55:58 +0100

starpu-contrib (1.4.5+dfsg-2build1) plucky; urgency=medium

  * No-change rebuild for openmpi soname change

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 01 Dec 2024 16:21:38 +0000

starpu-contrib (1.4.5+dfsg-2) unstable; urgency=medium

  * patches/gcc-14: Fix build with gcc 14.  Closes: Bug#1075537, Bug#1078230.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 07 Jul 2024 21:54:03 +0200

starpu-contrib (1.4.5+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Rename library packages according to abi bumps.
    - patches/avoid-version: Upstreamed.
    - patches/python-destdir: Upstreamed.
  * control: Replace pkg-config with pkgconf.
  * watch: Check signature.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 23 Apr 2024 16:17:42 +0200

=== debian/control ===
Source: starpu-contrib
Priority: optional
Maintainer: Samuel Thibault <sthibault@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
	chrpath,
	pkgconf,
	libnuma-dev [linux-any],
	libglpk-dev,
	mpi-default-dev,
	libgl-dev,
	libglu-dev,
	freeglut3-dev,
	libx11-dev,
	libblas-dev,
	libfftw3-dev,
	libhwloc-dev,
	libleveldb-dev,
	libhdf5-dev,
	libfxt-dev, pajeng,
	libpapi-dev [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el hppa ppc64 x32],
	python3-dev,
	libpython3-dev, python3-setuptools,
	python3-cloudpickle, python3-joblib, python3-numpy,
	clang      [amd64 arm64 armhf i386 mips64el ppc64el ppc64 riscv64],
	libomp-dev [amd64 arm64 armhf i386 mips64el ppc64el ppc64 riscv64],
	valgrind-if-available,
#	guile-2.2,
	opencl-c-headers, ocl-icd-opencl-dev | opencl-dev,
	gfortran,
	help2man, doxygen,
	nvidia-cuda-toolkit-gcc (>= 10.1),
Rules-Requires-Root: no
Standards-Version: 4.6.0
Section: contrib/libs
Homepage: https://starpu.gitlabpages.inria.fr/
Vcs-Git: https://salsa.debian.org/debian/starpu.git
Vcs-Browser: https://salsa.debian.org/debian/starpu

Package: libstarpu-contrib-dev
Section: contrib/libdevel
Architecture: any
Depends: libstarpu-contrib-1.4-5t64 (= ${binary:Version}) | libstarpu-contrib-any-1.4-5, libstarpu-contrib-openmp-llvm-1.4-1t64 (= ${binary:Version}) [amd64 arm64 armhf i386 mips64el ppc64el ppc64 riscv64] | libstarpu-contrib-any-openmp-llvm-1.4-1 [amd64 arm64 armhf i386 mips64el ppc64el ppc64 riscv64], libstarpu-contribfft-1.4-1t64 (= ${binary:Version}) | libstarpu-contrib-anyfft-1.4-1, libstarpu-contribmpi-1.4-3t64 (= ${binary:Version}) | libstarpu-contrib-anympi-1.4-3, libsocl-contrib-1.4-1t64 (= ${binary:Version}) | libsocl-contrib-any-1.4-1, libstarpu-contribrm-1.4-1t64 (= ${binary:Version}) | libstarpu-contrib-anyrm-1.4-1, ${misc:Depends}, libhwloc-dev, opencl-headers, ocl-icd-opencl-dev, libpapi-dev [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el hppa ppc64 x32]
Conflicts: libstarpu-dev
Provides: libstarpu-any-dev
Description: Task scheduler for heterogeneous multicore machines - dev
 StarPU is a runtime system that offers support for heterogeneous
 multicore machines. While many efforts are devoted to design efficient
 computation kernels for those architectures (e.g. to implement BLAS
 kernels on GPUs or on Cell's SPUs), StarPU not only takes care of
 offloading such kernels (and implementing data coherency across
 the machine), but it also makes sure the kernels are executed as
 efficiently as possible.
 .
 This package contains development headers and libraries.
 This "contrib" version is built against CUDA.

Package: libstarpu-contrib-1.4-5t64
Replaces: libstarpu-contrib-1.4-5
Breaks: libstarpu-contrib-1.4-5 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libstarpu-1.4-5, libstarpu-1.4-5t64
Provides: ${t64:Provides}, libstarpu-any-1.4-5
Description: Task scheduler for heterogeneous multicore machines
 StarPU is a runtime system that offers support for heterogeneous
 multicore machines. While many efforts are devoted to design efficient
 computation kernels for those architectures (e.g. to implement BLAS
 kernels on GPUs or on Cell's SPUs), StarPU not only takes care of
 offloading such kernels (and implementing data coherency across
 the machine), but it also makes sure the kernels are executed as
 efficiently as possible.
 .
 This package contains the main StarPU library
 This "contrib" version is built against CUDA.

Package: libstarpu-contrib-openmp-llvm-1.4-1t64
Replaces: libstarpu-contrib-openmp-llvm-1.4-1
Breaks: libstarpu-contrib-openmp-llvm-1.4-1 (<< ${source:Version})
Architecture: amd64 arm64 armhf i386 mips64el ppc64el ppc64 riscv64
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libstarpu-openmp-llvm-1.4-1, libstarpu-openmp-llvm-1.4-1t64
Provides: ${t64:Provides}, libstarpu-any-openmp-llvm-1.4-1
Description: Task scheduler for heterogeneous multicore machines
 StarPU is a runtime system that offers support for heterogeneous
 multicore machines. While many efforts are devoted to design efficient
 computation kernels for those architectures (e.g. to implement BLAS
 kernels on GPUs or on Cell's SPUs), StarPU not only takes care of
 offloading such kernels (and implementing data coherency across
 the machine), but it also makes sure the kernels are executed as
 efficiently as possible.
 .
 This package contains the runtime support for LLVM OpenMP.
 This "contrib" version is built against CUDA.

Package: libstarpu-contribfft-1.4-1t64
Replaces: libstarpu-contribfft-1.4-1
Breaks: libstarpu-contribfft-1.4-1 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libstarpufft-1.4-1, libstarpufft-1.4-1t64
Provides: ${t64:Provides}, libstarpu-anyfft-1.4-1
Description: Task scheduler for heterogeneous multicore machines
 StarPU is a runtime system that offers support for heterogeneous
 multicore machines. While many efforts are devoted to design efficient
 computation kernels for those architectures (e.g. to implement BLAS
 kernels on GPUs or on Cell's SPUs), StarPU not only takes care of
 offloading such kernels (and implementing data coherency across
 the machine), but it also makes sure the kernels are executed as
 efficiently as possible.
 .
 This package contains a hybrid CPU+GPU FFT library.
 This "contrib" version is built against CUDA.

Package: libstarpu-contribmpi-1.4-3t64
Replaces: libstarpu-contribmpi-1.4-3
Breaks: libstarpu-contribmpi-1.4-3 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libstarpumpi-1.4-3, libstarpumpi-1.4-3t64
Provides: ${t64:Provides}, libstarpu-anympi-1.4-3
Description: Task scheduler for heterogeneous multicore machines
 StarPU is a runtime system that offers support for heterogeneous
 multicore machines. While many efforts are devoted to design efficient
 computation kernels for those architectures (e.g. to implement BLAS
 kernels on GPUs or on Cell's SPUs), StarPU not only takes care of
 offloading such kernels (and implementing data coherency across
 the machine), but it also makes sure the kernels are executed as
 efficiently as possible.
 .
 This package contains MPI extensions for StarPU.
 This "contrib" version is built against CUDA.

Package: starpu-contrib-tools
Section: contrib/utils
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: starpu-tools
Provides: starpu-any-tools
Recommends: python3:any
Description: Task scheduler for heterogeneous multicore machines - tools
 StarPU is a runtime system that offers support for heterogeneous
 multicore machines. While many efforts are devoted to design efficient
 computation kernels for those architectures (e.g. to implement BLAS
 kernels on GPUs or on Cell's SPUs), StarPU not only takes care of
 offloading such kernels (and implementing data coherency across
 the machine), but it also makes sure the kernels are executed as
 efficiently as possible.
 .
 This package contains StarPU tools.
 This "contrib" version is built against CUDA.

Package: starpu-contrib-examples
Section: contrib/science
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libstarpu-contrib-1.4-1, libstarpu-contrib-1.4-1, libstarpu-1.4-2, libstarpu-contrib-1.4-2
Replaces: libstarpu-contrib-1.4-1, libstarpu-contrib-1.4-1, libstarpu-1.4-2, libstarpu-contrib-1.4-2
Conflicts: starpu-examples
Provides: starpu-any-examples
Description: Task scheduler for heterogeneous multicore machines - exs
 StarPU is a runtime system that offers support for heterogeneous
 multicore machines. While many efforts are devoted to design efficient
 computation kernels for those architectures (e.g. to implement BLAS
 kernels on GPUs or on Cell's SPUs), StarPU not only takes care of
 offloading such kernels (and implementing data coherency across
 the machine), but it also makes sure the kernels are executed as
 efficiently as possible.
 .
 This package contains application examples.
 This "contrib" version is built against CUDA.

Package: libsocl-contrib-1.4-1t64
Replaces: libsocl-contrib-1.4-1
Breaks: libsocl-contrib-1.4-1 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libsocl-1.4-1, libsocl-1.4-1t64
Provides: ${t64:Provides}, libsocl-any-1.4-1
Description: Task scheduler for heterogeneous multicore machines
 StarPU is a runtime system that offers support for heterogeneous
 multicore machines. While many efforts are devoted to design efficient
 computation kernels for those architectures (e.g. to implement BLAS
 kernels on GPUs or on Cell's SPUs), StarPU not only takes care of
 offloading such kernels (and implementing data coherency across
 the machine), but it also makes sure the kernels are executed as
 efficiently as possible.
 .
 This package contains an OpenCL-compatible library interface to StarPU.
 This "contrib" version is built against CUDA.

Package: libstarpu-contribrm-1.4-1t64
Replaces: libstarpu-contribrm-1.4-1
Breaks: libstarpu-contribrm-1.4-1 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libstarpurm-1.4-1, libstarpurm-1.4-1t64
Provides: ${t64:Provides}, libstarpu-anyrm-1.4-1
Description: Task scheduler for heterogeneous multicore machines
 StarPU is a runtime system that offers support for heterogeneous
 multicore machines. While many efforts are devoted to design efficient
 computation kernels for those architectures (e.g. to implement BLAS
 kernels on GPUs or on Cell's SPUs), StarPU not only takes care of
 offloading such kernels (and implementing data coherency across
 the machine), but it also makes sure the kernels are executed as
 efficiently as possible.
 .
 This package contains the resource management library.
 This "contrib" version is built against CUDA.

## starpu-contrib 1.4.7+dfsg

=== doc/tutorial/Makefile ===
# StarPU --- Runtime system for heterogeneous multicore architectures.
#
# Copyright (C) 2009-2024  Université de Bordeaux, CNRS (LaBRI UMR 5800), Inria
#
# StarPU is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation; either version 2.1 of the License, or (at
# your option) any later version.
#
# StarPU is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
# See the GNU Lesser General Public License in COPYING.LGPL for more details.
#
CFLAGS          +=      $$(pkg-config --cflags starpu-1.4)
LDLIBS          +=      $$(pkg-config --libs starpu-1.4)

HAS_CUDA	=	$(shell starpu_config | grep 'STARPU_USE_CUDA 1')
NVCC		?=	nvcc -std=c++11
HAS_OPENCL	=	$(shell starpu_config | grep 'STARPU_USE_OPENCL 1')

%.o: %.cu
	$(NVCC) $(CFLAGS) $< -c

TARGETS = hello_world vector_scal

all: $(TARGETS)

VECTOR_SCAL_PREREQUISITES	=	vector_scal.o vector_scal_cpu.o
ifneq ($(strip $(HAS_CUDA)),)
VECTOR_SCAL_PREREQUISITES	+=	vector_scal_cuda.o
VECTOR_SCAL_COMPILER		=	$(NVCC)
else
VECTOR_SCAL_COMPILER		=	$(CC)
endif
ifneq ($(strip $(HAS_OPENCL)),)
VECTOR_SCAL_PREREQUISITES 	+=	vector_scal_opencl.o
LDLIBS				+=	-lOpenCL
endif

vector_scal: $(VECTOR_SCAL_PREREQUISITES)
	$(VECTOR_SCAL_COMPILER) $^ $(LDLIBS) -o $@ $(LDFLAGS)

clean:
	rm -f $(TARGETS) *.o

=== examples/fortran/Makefile ===
# StarPU --- Runtime system for heterogeneous multicore architectures.
#
# Copyright (C) 2009-2022  Université de Bordeaux, CNRS (LaBRI UMR 5800), Inria
#
# StarPU is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation; either version 2.1 of the License, or (at
# your option) any later version.
#
# StarPU is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
# See the GNU Lesser General Public License in COPYING.LGPL for more details.
#
FC=gfortran
CFLAGS+= -g -Wall
FFLAGS+= -g -Wall

all: hello

hello.F: starpu_fortran.h

hello: hello.F hello_c.o

clean:
	rm -f *.o *.mod hello

=== debian/changelog ===
starpu-contrib (1.4.7+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- Samuel Thibault <sthibault@debian.org>  Wed, 02 Apr 2025 20:01:07 +0200

starpu-contrib (1.4.7+dfsg-1) experimental; urgency=medium

  * New upstream release.
    - Rename libstarpu-1.4-5t64 to libstarpu-1.4-6 according to soname bump.
    - patches/hipblas: Refresh.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 01 Apr 2025 16:32:49 +0200

starpu-contrib (1.4.5+dfsg-5) unstable; urgency=medium

  * control: Re-enable llvm omp and libstarpu-openmp-llvm package on mips64el,
    riscv64, and enable on loong64.
  * patches/gcc-15: Fix build with gcc-15 (Closes: Bug#1097937)
  * patches/hipblas: Fix hip build.
  * control: Add libamdhip64-dev and libhipblas-dev build-deps.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 01 Apr 2025 16:31:26 +0200

starpu-contrib (1.4.5+dfsg-4) unstable; urgency=medium

  * control: Drop libstarpu-openmp-llvm package on i386, mips64el, riscv64.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 10 Nov 2024 22:47:49 +0100

starpu-contrib (1.4.5+dfsg-3) unstable; urgency=medium

  * control,rules: Disable llvm omp on i386, mips64el, riscv64.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 10 Nov 2024 21:41:46 +0100

=== debian/control ===
--- 
+++ 
@@ -21,11 +21,12 @@
 	python3-dev,
 	libpython3-dev, python3-setuptools,
 	python3-cloudpickle, python3-joblib, python3-numpy,
-	clang      [amd64 arm64 armhf i386 mips64el ppc64el ppc64 riscv64],
-	libomp-dev [amd64 arm64 armhf i386 mips64el ppc64el ppc64 riscv64],
+	clang      [amd64 arm64 armhf mips64el ppc64el riscv64 ppc64 loong64],
+	libomp-dev [amd64 arm64 armhf mips64el ppc64el riscv64 ppc64 loong64],
 	valgrind-if-available,
 #	guile-2.2,
 	opencl-c-headers, ocl-icd-opencl-dev | opencl-dev,
+	libamdhip64-dev [amd64 arm64 ppc64el], libhipblas-dev [amd64 arm64 ppc64el],
 	gfortran,
 	help2man, doxygen,
 	nvidia-cuda-toolkit-gcc (>= 10.1),
@@ -39,7 +40,15 @@
 Package: libstarpu-contrib-dev
 Section: contrib/libdevel
 Architecture: any
-Depends: libstarpu-contrib-1.4-5t64 (= ${binary:Version}) | libstarpu-contrib-any-1.4-5, libstarpu-contrib-openmp-llvm-1.4-1t64 (= ${binary:Version}) [amd64 arm64 armhf i386 mips64el ppc64el ppc64 riscv64] | libstarpu-contrib-any-openmp-llvm-1.4-1 [amd64 arm64 armhf i386 mips64el ppc64el ppc64 riscv64], libstarpu-contribfft-1.4-1t64 (= ${binary:Version}) | libstarpu-contrib-anyfft-1.4-1, libstarpu-contribmpi-1.4-3t64 (= ${binary:Version}) | libstarpu-contrib-anympi-1.4-3, libsocl-contrib-1.4-1t64 (= ${binary:Version}) | libsocl-contrib-any-1.4-1, libstarpu-contribrm-1.4-1t64 (= ${binary:Version}) | libstarpu-contrib-anyrm-1.4-1, ${misc:Depends}, libhwloc-dev, opencl-headers, ocl-icd-opencl-dev, libpapi-dev [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el hppa ppc64 x32]
+Depends: libstarpu-contrib-1.4-6 (= ${binary:Version}) | libstarpu-contrib-any-1.4-6,
+	libstarpu-openmp-llvm-1.4-1t64 (= ${binary:Version}) [amd64 arm64 armhf mips64el ppc64el riscv64 ppc64 loong64] | libstarpu-any-openmp-llvm-1.4-1 [amd64 arm64 armhf mips64el ppc64el riscv64 ppc64 loong64],
+	libstarpufft-1.4-1t64 (= ${binary:Version}) | libstarpu-anyfft-1.4-1,
+	libstarpumpi-1.4-3t64 (= ${binary:Version}) | libstarpu-anympi-1.4-3,
+	libsocl-1.4-1t64 (= ${binary:Version}) | libsocl-any-1.4-1,
+	libstarpurm-1.4-1t64 (= ${binary:Version}) | libstarpu-anyrm-1.4-1,
+	${misc:Depends},
+	libhwloc-dev, opencl-headers, ocl-icd-opencl-dev,
+	libpapi-dev [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el hppa ppc64 x32]
 Conflicts: libstarpu-dev
 Provides: libstarpu-any-dev
 Description: Task scheduler for heterogeneous multicore machines - dev
@@ -54,14 +63,12 @@
  This package contains development headers and libraries.
  This "contrib" version is built against CUDA.
 
-Package: libstarpu-contrib-1.4-5t64
-Replaces: libstarpu-contrib-1.4-5
-Breaks: libstarpu-contrib-1.4-5 (<< ${source:Version})
-Architecture: any
-Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: libstarpu-1.4-5, libstarpu-1.4-5t64
-Provides: ${t64:Provides}, libstarpu-any-1.4-5
+Package: libstarpu-contrib-1.4-6
+Architecture: any
+Multi-Arch: same
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Conflicts: libstarpu-1.4-6
+Provides: libstarpu-any-1.4-6
 Description: Task scheduler for heterogeneous multicore machines
  StarPU is a runtime system that offers support for heterogeneous
  multicore machines. While many efforts are devoted to design efficient
@@ -77,7 +84,7 @@
 Package: libstarpu-contrib-openmp-llvm-1.4-1t64
 Replaces: libstarpu-contrib-openmp-llvm-1.4-1
 Breaks: libstarpu-contrib-openmp-llvm-1.4-1 (<< ${source:Version})
-Architecture: amd64 arm64 armhf i386 mips64el ppc64el ppc64 riscv64
+Architecture: amd64 arm64 armhf mips64el ppc64el riscv64 ppc64 loong64
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Conflicts: libstarpu-openmp-llvm-1.4-1, libstarpu-openmp-llvm-1.4-1t64

=== debian/rules ===
#!/usr/bin/make -f

# This may bring unexpected warnings/errors
undefine STARPU_DEVEL

DH_OPTIONS=-Bbuild

# These are the best versions that nvcc supports.
CONTRIB_GCC_VERSION  := 8
CONTRIB_CLANG_VERSION  := 8

ifeq ($(DEB_SOURCE),starpu-contrib)
# nvcc sometimes chokes on some gcc features
CC=cuda-gcc
CXX=cuda-g++
endif
OMPI_CC=$(CC)
export CC
export CXX
export OMPI_CC

export NVCCFLAGS = -Xcompiler -fPIC -Xcompiler -std=c++03

ifneq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
CONFIGURE_NODOC = --disable-build-doc
endif

DO_PACKAGES := $(subst -contrib,,$(shell dh_listpackages))
ifneq (,$(filter libstarpu-openmp-llvm-1.4-1t64,$(DO_PACKAGES)))
OPENMP_LLVM=1
else
OPENMP_LLVM=0
endif

ifeq ($(OPENMP_LLVM),1)
CONFIGURE_OPENMP_LLVM = --enable-openmp-llvm
endif

%:
	dh $@ $(DH_OPTIONS)

override_dh_auto_configure:
	dh_auto_configure $(DH_OPTIONS) -- \
		--enable-opengl-render \
		--enable-openmp \
		--enable-quick-check \
		--enable-mlr-system-blas \
		--enable-starpurm \
		--enable-starpurm-examples \
		--enable-maxnodes=16 \
		--enable-maxcpus=32 \
		--enable-maxnumanodes=4 \
		--enable-tcpip-master-slave \
		--docdir=/usr/share/doc/libstarpu-dev --disable-build-doc-pdf \
		$(CONFIGURE_OPENMP_LLVM) \
		$(CONFIGURE_NODOC)

override_dh_auto_test:
	-HOME=$$PWD DISPLAY= DEB_BUILD_OPTIONS=$(patsubst parallel=%,,$(DEB_BUILD_OPTIONS)) dh_auto_test $(DH_OPTIONS) -- -k
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) -C build showcheck
endif

override_dh_auto_install:
	dh_auto_install
ifeq ($(OPENMP_LLVM),1)
	# Debian does symlink libomp into libdir
	chrpath -d $(CURDIR)/debian/tmp/usr/lib/*/starpu/examples/starpu_openmp_llvm/hello-task
endif

override_dh_auto_clean:
	# No idea why salsa CI is adding +x on libsocl-1.3-0.install and libstarpu-1.3-5.install (and no others...)
	ls -l debian/*.install
	chmod -x debian/*.install
	dh_auto_clean $(DH_OPTIONS)
	rm -fr doc/doxygen/starpu.pdf
	rm -fr doc/doxygen/html
	rm -fr .starpu
	rm -fr .nv

# Switch to main rules
sw-main:
	sed -i 's/^starpu-contrib /starpu /' debian/changelog
	sed -i '1s/^Source: starpu-contrib/Source: starpu/' debian/control
	sed -i 's/Package: libstarpu-contrib/Package: libstarpu/' debian/control
	sed -i 's/Package: starpu-contrib/Package: starpu/' debian/control
	sed -i 's/Package: libsocl-contrib/Package: libsocl/' debian/control
	sed -i '/Depends/s/ libstarpu-contrib/ libstarpu/g' debian/control
	sed -i '/Depends/s/ libsocl-contrib/ libsocl/g' debian/control
	sed -i 's/Replaces: libstarpu-contrib/Replaces: libstarpu/' debian/control
	sed -i 's/Replaces: libsocl-contrib/Replaces: libsocl/' debian/control
	sed -i 's/Replaces: starpu-contrib/Replaces: starpu/' debian/control
	sed -i 's/Breaks: libstarpu-contrib/Breaks: libstarpu/' debian/control
	sed -i 's/Breaks: libsocl-contrib/Breaks: libsocl/' debian/control
	sed -i 's/Breaks: starpu-contrib/Breaks: starpu/' debian/control
	sed -i '/^Conflicts:/s/ libstarpu/ libstarpu-contrib/g' debian/control
	sed -i '/^Conflicts:/s/ libsocl/ libsocl-contrib/g' debian/control
	sed -i '/^Conflicts:/s/ starpu/ starpu-contrib/g' debian/control
	sed -i 's/^	nvidia-cuda-toolkit-gcc/#	nvidia-cuda-toolkit-gcc/' debian/control
	sed -i 's_^Section: contrib/_Section: _' debian/control
	sed -i 's/contrib-contrib/contrib/g' debian/control debian/changelog
	sed -i 's/^ This "contrib" version/# This "contrib" version/' debian/control

# Switch to contrib rules
sw-contrib:
	sed -i 's/^starpu /starpu-contrib /' debian/changelog
	sed -i '1s/^Source: starpu/Source: starpu-contrib/' debian/control
	sed -i 's/Package: libstarpu/Package: libstarpu-contrib/' debian/control
	sed -i 's/Package: starpu/Package: starpu-contrib/' debian/control
	sed -i 's/Package: libsocl/Package: libsocl-contrib/' debian/control
	sed -i '/Depends/s/ libstarpu/ libstarpu-contrib/g' debian/control
	sed -i '/Depends/s/ libsocl/ libsocl-contrib/g' debian/control
	sed -i 's/Replaces: libstarpu/Replaces: libstarpu-contrib/' debian/control
	sed -i 's/Replaces: libsocl/Replaces: libsocl-contrib/' debian/control
	sed -i 's/Replaces: starpu/Replaces: starpu-contrib/' debian/control
	sed -i 's/Breaks: libstarpu/Breaks: libstarpu-contrib/' debian/control
	sed -i 's/Breaks: libsocl/Breaks: libsocl-contrib/' debian/control
	sed -i 's/Breaks: starpu/Breaks: starpu-contrib/' debian/control
	sed -i '/^Conflicts:/s/ libstarpu-contrib/ libstarpu/g' debian/control
	sed -i '/^Conflicts:/s/ libsocl-contrib/ libsocl/g' debian/control
	sed -i '/^Conflicts:/s/ starpu-contrib/ starpu/g' debian/control
	sed -i 's/#	nvidia-cuda-toolkit-gcc/	nvidia-cuda-toolkit-gcc/' debian/control
	sed -i 's_contrib/contrib/_contrib_g' debian/control debian/control
	sed -i 's/contrib-contrib/contrib/g' debian/control debian/changelog
	sed -i 's_^Section: \([^/]*\)$$_Section: contrib/\1_' debian/control
	sed -i 's/^# This "contrib" version/ This "contrib" version/' debian/control

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg\d*$//,uversionmangle=s/(\d)(rc\d*)$/$1~$2/,pgpsigurlmangle=s/$/.asc/ \
https://files.inria.fr/starpu/ \
(?:|.*/)starpu(?:[_\-]v?|)@ANY_VERSION@@ARCHIVE_EXT@

## starpu-contrib 1.4.8+dfsg

=== min-dgels/Makefile ===
CC = gcc
LD = /usr/bin/ld -m elf_x86_64
srcdir = .

CLAPACK=base
ADDITIONAL=additional

all:
	mkdir -p build
	[ -d "$(CLAPACK)" ] || ( cp -a $(srcdir)/$(CLAPACK) . ; chmod -R +rwX $(CLAPACK) )
	cd $(CLAPACK) && $(MAKE) blaslib CC="$(CC)" LD="$(LD)"
	cd $(CLAPACK) && $(MAKE) f2clib CC="$(CC)" LD="$(LD)"
	[ -d "$(ADDITIONAL)" ] || ( cp -a $(srcdir)/$(ADDITIONAL) . ; chmod -R +rwX $(ADDITIONAL) )
	cd $(ADDITIONAL) && $(CC) -c -fPIC *.c && ar cr ../build/minlibdgels.a *.o && ranlib ../build/minlibdgels.a

install:
installcheck:
uninstall:
distuninstallcheck:
dvi:

clean:
	-cd $(CLAPACK) && $(MAKE) clean && rm -rf *~
	-cd $(ADDITIONAL) && rm -rf *.o *~
	rm -rf build *~

distclean: clean
	[ -f Makefile.in ] || rm -fr $(CLAPACK) $(ADDITIONAL)

# This part is needed by StarPU

STARPU_SRCDIR = .

distdir:
	cp -fRp $(STARPU_SRCDIR)/* $(distdir)
	cd $(distdir) && make -f Makefile.in clean

check:
	echo "No checks are implemented for min-dgels"

showfailed:
	@:

showcheck: check

showsuite: check

recheck: check

=== doc/tutorial/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # StarPU --- Runtime system for heterogeneous multicore architectures.
 #
-# Copyright (C) 2009-2024  Université de Bordeaux, CNRS (LaBRI UMR 5800), Inria
+# Copyright (C) 2009-2025  University of Bordeaux, CNRS (LaBRI UMR 5800), Inria
 #
 # StarPU is free software; you can redistribute it and/or modify
 # it under the terms of the GNU Lesser General Public License as published by

=== tools/release/Makefile ===
# StarPU --- Runtime system for heterogeneous multicore architectures.
#
# Copyright (C) 2009-2025  University of Bordeaux, CNRS (LaBRI UMR 5800), Inria
#
# StarPU is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation; either version 2.1 of the License, or (at
# your option) any later version.
#
# StarPU is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
# See the GNU Lesser General Public License in COPYING.LGPL for more details.
#
STARPU		?=	undefined
EXAMPLE		?= 	undefined

TARGETS		=
TARGETS		+=	hello_world
TARGETS 	+=	block
TARGETS		+=	mult
TARGETS		+=	variable
TARGETS		+=	incrementer

ifeq ($(STARPU),undefined)
all:
	@echo
	@echo "ERROR. You need to set the variable STARPU to the name of the pkg-config StarPU package"
	@echo
clean:; rm -f $(TARGETS) *.o

else
ifeq ($(EXAMPLE),undefined)
all:
	@echo
	@echo "ERROR. You need to set the variable EXAMPLE to the directory hosting the example sources"
	@echo
clean:; rm -f $(TARGETS) *.o

else

CFLAGS          +=      $$(pkg-config --cflags $(STARPU))
LDFLAGS         +=      $$(pkg-config --libs $(STARPU))

HAS_CUDA	=	$(shell starpu_config -d | grep -c STARPU_USE_CUDA)
NVCC		?=	nvcc
HAS_OPENCL	=	$(shell starpu_config -d | grep -c STARPU_USE_OPENCL)

ifneq ($(strip $(HAS_CUDA)),0)
LDFLAGS		+=	-lcudart
endif

ifneq ($(strip $(HAS_OPENCL)),0)
LDFLAGS		+=	-lOpenCL
endif

%: %.o
	$(CC) $< $(LDFLAGS) -o $@
%.o: $(EXAMPLE)/basic_examples/%.cu
	$(NVCC) -std=c++11 $(CFLAGS) $< -c
%.o: $(EXAMPLE)/basic_examples/%.c
	$(CC) $(CFLAGS) $< -c

%.o: $(EXAMPLE)/incrementer/%.cu
	$(NVCC) -std=c++11 $(CFLAGS) $< -c
%.o: $(EXAMPLE)/incrementer/%.c
	$(CC) $(CFLAGS) $< -c

all: $(TARGETS)

BLOCK_PREREQUISITES	=	block.o block_cpu.o
ifneq ($(strip $(HAS_CUDA)),0)
BLOCK_PREREQUISITES	+=	block_cuda.o
endif
ifneq ($(strip $(HAS_OPENCL)),0)
BLOCK_PREREQUISITES    +=	block_opencl.o
endif
block: $(BLOCK_PREREQUISITES)
	$(CC) $^ $(LDFLAGS) -o $@

VARIABLE_PREREQUISITES	=	variable.o variable_kernels_cpu.o
ifneq ($(strip $(HAS_CUDA)),)
VARIABLE_PREREQUISITES	+=	variable_kernels.o
endif
ifneq ($(strip $(HAS_OPENCL)),)
VARIABLE_PREREQUISITES    +=	variable_kernels_opencl.o
endif
variable: $(VARIABLE_PREREQUISITES)
	$(CC) $^ $(LDFLAGS) -o $@

INCREMENTER_PREREQUISITES	=	incrementer.o
ifneq ($(strip $(HAS_CUDA)),)
INCREMENTER_PREREQUISITES	+=	incrementer_kernels.o
endif
ifneq ($(strip $(HAS_OPENCL)),)
INCREMENTER_PREREQUISITES    +=	incrementer_kernels_opencl.o
endif
incrementer: $(INCREMENTER_PREREQUISITES)
	$(CC) $^ $(LDFLAGS) -o $@

MULT_PREREQUISITES	=	mult.o
ifneq ($(strip $(HAS_CUDA)),0)
MULT_PREREQUISITES	+=	mult_cuda.o
endif
mult: $(MULT_PREREQUISITES)
	$(CC) $^ $(LDFLAGS) -o $@

clean:; rm -f $(TARGETS) *.o


endif
endif

=== debian/changelog ===
starpu-contrib (1.4.8+dfsg-2) unstable; urgency=medium

  * control: Drop version of dependency on pkg-rocm-tools.

 -- Samuel Thibault <sthibault@debian.org>  Thu, 14 Aug 2025 22:47:01 +0200

starpu-contrib (1.4.8+dfsg-1) unstable; urgency=low

  * New upstream release.
    - Rename libstarpu-1.4-6 to libstarpu-1.4-7 according to soname bump.
    - patches/gcc-14: Upstreamed.
    - patches/gcc-15: Upstreamed.
    - patches/hipblas: Upstreamed.
  * Re-export upstream signing key without extra signatures.
  * Update standards version to 4.6.2, no changes needed.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 12 Aug 2025 00:39:30 +0200

starpu-contrib (1.4.7+dfsg-2+exp3) experimental; urgency=medium

  * patches/hip-opencl: Fix hip / OpenCL clash.
  * tests/examples: Run all tests before failing.
  * control: build-depend on pkg-rocm-tools that provides the list of archs to
    build for.
  * rules: Use rocm-target-arch to get list of HIP archs.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 22 Jul 2025 20:46:33 +0200

starpu-contrib (1.4.7+dfsg-2+exp2) experimental; urgency=medium

  * rules: Disable dh_dwz.

 -- Samuel Thibault <sthibault@debian.org>  Mon, 21 Jul 2025 22:29:38 +0200

starpu-contrib (1.4.7+dfsg-2+exp1) experimental; urgency=medium

  * control: Add missing hipcc and librocblas-dev packages for HIP support.
  * tests/control: Add rocm CI test.
  * tests/examples: Also run starpu_machine_display.

 -- Samuel Thibault <sthibault@debian.org>  Mon, 21 Jul 2025 20:27:42 +0200

=== debian/control ===
--- 
+++ 
@@ -26,12 +26,13 @@
 	valgrind-if-available,
 #	guile-2.2,
 	opencl-c-headers, ocl-icd-opencl-dev | opencl-dev,
-	libamdhip64-dev [amd64 arm64 ppc64el], libhipblas-dev [amd64 arm64 ppc64el],
+	libamdhip64-dev [amd64 arm64 ppc64el], hipcc [amd64 arm64 ppc64el], libhipblas-dev [amd64 arm64 ppc64el], librocblas-dev [amd64 arm64 ppc64el],
+	pkg-rocm-tools,
 	gfortran,
 	help2man, doxygen,
 	nvidia-cuda-toolkit-gcc (>= 10.1),
 Rules-Requires-Root: no
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Section: contrib/libs
 Homepage: https://starpu.gitlabpages.inria.fr/
 Vcs-Git: https://salsa.debian.org/debian/starpu.git
@@ -40,7 +41,7 @@
 Package: libstarpu-contrib-dev
 Section: contrib/libdevel
 Architecture: any
-Depends: libstarpu-contrib-1.4-6 (= ${binary:Version}) | libstarpu-contrib-any-1.4-6,
+Depends: libstarpu-contrib-1.4-7 (= ${binary:Version}) | libstarpu-contrib-any-1.4-7,
 	libstarpu-openmp-llvm-1.4-1t64 (= ${binary:Version}) [amd64 arm64 armhf mips64el ppc64el riscv64 ppc64 loong64] | libstarpu-any-openmp-llvm-1.4-1 [amd64 arm64 armhf mips64el ppc64el riscv64 ppc64 loong64],
 	libstarpufft-1.4-1t64 (= ${binary:Version}) | libstarpu-anyfft-1.4-1,
 	libstarpumpi-1.4-3t64 (= ${binary:Version}) | libstarpu-anympi-1.4-3,
@@ -63,12 +64,12 @@
  This package contains development headers and libraries.
  This "contrib" version is built against CUDA.
 
-Package: libstarpu-contrib-1.4-6
-Architecture: any
-Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: libstarpu-1.4-6
-Provides: libstarpu-any-1.4-6
+Package: libstarpu-contrib-1.4-7
+Architecture: any
+Multi-Arch: same
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Conflicts: libstarpu-1.4-7
+Provides: libstarpu-any-1.4-7
 Description: Task scheduler for heterogeneous multicore machines
  StarPU is a runtime system that offers support for heterogeneous
  multicore machines. While many efforts are devoted to design efficient

=== debian/rules ===
--- 
+++ 
@@ -20,6 +20,7 @@
 export OMPI_CC
 
 export NVCCFLAGS = -Xcompiler -fPIC -Xcompiler -std=c++03
+export HIPCCFLAGS = $(foreach arch,$(shell rocm-target-arch),--offload-arch=$(arch))
 
 ifneq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
 CONFIGURE_NODOC = --disable-build-doc
@@ -67,6 +68,9 @@
 	# Debian does symlink libomp into libdir
 	chrpath -d $(CURDIR)/debian/tmp/usr/lib/*/starpu/examples/starpu_openmp_llvm/hello-task
 endif
+
+override_dh_dwz:
+	:
 
 override_dh_auto_clean:
 	# No idea why salsa CI is adding +x on libsocl-1.3-0.install and libstarpu-1.3-5.install (and no others...)

## starpu-contrib 1.4.9%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
 	libleveldb-dev,
 	libhdf5-dev,
 	libfxt-dev, pajeng,
-	libpapi-dev [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el hppa ppc64 x32],
+	libpapi-dev [!s390x !alpha !hurd-any !m68k !powerpc !sh4 !sparc64],
 	python3-dev,
 	libpython3-dev, python3-setuptools,
 	python3-cloudpickle, python3-joblib, python3-numpy,
@@ -26,7 +26,8 @@
 	valgrind-if-available,
 #	guile-2.2,
 	opencl-c-headers, ocl-icd-opencl-dev | opencl-dev,
-	libamdhip64-dev [amd64 arm64 ppc64el], hipcc [amd64 arm64 ppc64el], libhipblas-dev [amd64 arm64 ppc64el], librocblas-dev [amd64 arm64 ppc64el],
+	libamdhip64-dev [amd64 arm64 ppc64el], hipcc [amd64 arm64 ppc64el],
+#	libhipblas-dev [amd64 arm64 ppc64el], librocblas-dev [amd64 arm64 ppc64el],
 	pkg-rocm-tools,
 	gfortran,
 	help2man, doxygen,
@@ -41,15 +42,17 @@
 Package: libstarpu-contrib-dev
 Section: contrib/libdevel
 Architecture: any
-Depends: libstarpu-contrib-1.4-7 (= ${binary:Version}) | libstarpu-contrib-any-1.4-7,
-	libstarpu-openmp-llvm-1.4-1t64 (= ${binary:Version}) [amd64 arm64 armhf mips64el ppc64el riscv64 ppc64 loong64] | libstarpu-any-openmp-llvm-1.4-1 [amd64 arm64 armhf mips64el ppc64el riscv64 ppc64 loong64],
-	libstarpufft-1.4-1t64 (= ${binary:Version}) | libstarpu-anyfft-1.4-1,
-	libstarpumpi-1.4-3t64 (= ${binary:Version}) | libstarpu-anympi-1.4-3,
-	libsocl-1.4-1t64 (= ${binary:Version}) | libsocl-any-1.4-1,
-	libstarpurm-1.4-1t64 (= ${binary:Version}) | libstarpu-anyrm-1.4-1,
+Depends: libstarpu-contrib-1.4-8 (= ${binary:Version}) | libstarpu-any-1.4-8,
+	libstarpu-contrib-openmp-llvm-1.4-1t64 (= ${binary:Version}) [amd64 arm64 armhf mips64el ppc64el riscv64 ppc64 loong64] | libstarpu-any-openmp-llvm-1.4-1 [amd64 arm64 armhf mips64el ppc64el riscv64 ppc64 loong64],
+	libstarpu-contribfft-1.4-1t64 (= ${binary:Version}) | libstarpu-anyfft-1.4-1,
+	libstarpu-contribmpi-1.4-3t64 (= ${binary:Version}) | libstarpu-anympi-1.4-3,
+	libsocl-contrib-1.4-1t64 (= ${binary:Version}) | libsocl-any-1.4-1,
+	libstarpu-contribrm-1.4-1t64 (= ${binary:Version}) | libstarpu-anyrm-1.4-1,
 	${misc:Depends},
-	libhwloc-dev, opencl-headers, ocl-icd-opencl-dev,
-	libpapi-dev [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el hppa ppc64 x32]
+	libhwloc-dev,
+	libpapi-dev [!s390x !alpha !hurd-any !m68k !powerpc !sh4 !sparc64],
+	opencl-headers, ocl-icd-opencl-dev,
+	libamdhip64-dev [amd64 arm64 ppc64el], libhipblas-dev [amd64 arm64 ppc64el], librocblas-dev [amd64 arm64 ppc64el],
 Conflicts: libstarpu-dev
 Provides: libstarpu-any-dev
 Description: Task scheduler for heterogeneous multicore machines - dev
@@ -64,12 +67,12 @@
  This package contains development headers and libraries.
  This "contrib" version is built against CUDA.
 
-Package: libstarpu-contrib-1.4-7
-Architecture: any
-Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: libstarpu-1.4-7
-Provides: libstarpu-any-1.4-7
+Package: libstarpu-contrib-1.4-8
+Architecture: any
+Multi-Arch: same
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Conflicts: libstarpu-1.4-8
+Provides: libstarpu-any-1.4-8
 Description: Task scheduler for heterogeneous multicore machines
  StarPU is a runtime system that offers support for heterogeneous
  multicore machines. While many efforts are devoted to design efficient
@@ -88,7 +91,7 @@
 Architecture: amd64 arm64 armhf mips64el ppc64el riscv64 ppc64 loong64
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: libstarpu-openmp-llvm-1.4-1, libstarpu-openmp-llvm-1.4-1t64
+Conflicts: libstarpu-openmp-llvm-1.4-1, libstarpu-contrib-openmp-llvm-1.4-1t64
 Provides: ${t64:Provides}, libstarpu-any-openmp-llvm-1.4-1
 Description: Task scheduler for heterogeneous multicore machines
  StarPU is a runtime system that offers support for heterogeneous
@@ -108,7 +111,7 @@
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: libstarpufft-1.4-1, libstarpufft-1.4-1t64
+Conflicts: libstarpufft-1.4-1, libstarpu-contribfft-1.4-1t64
 Provides: ${t64:Provides}, libstarpu-anyfft-1.4-1
 Description: Task scheduler for heterogeneous multicore machines
  StarPU is a runtime system that offers support for heterogeneous
@@ -128,7 +131,7 @@
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: libstarpumpi-1.4-3, libstarpumpi-1.4-3t64
+Conflicts: libstarpumpi-1.4-3, libstarpu-contribmpi-1.4-3t64
 Provides: ${t64:Provides}, libstarpu-anympi-1.4-3
 Description: Task scheduler for heterogeneous multicore machines
  StarPU is a runtime system that offers support for heterogeneous
@@ -189,7 +192,7 @@
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: libsocl-1.4-1, libsocl-1.4-1t64
+Conflicts: libsocl-1.4-1, libsocl-contrib-1.4-1t64
 Provides: ${t64:Provides}, libsocl-any-1.4-1
 Description: Task scheduler for heterogeneous multicore machines
  StarPU is a runtime system that offers support for heterogeneous
@@ -209,7 +212,7 @@
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: libstarpurm-1.4-1, libstarpurm-1.4-1t64
+Conflicts: libstarpurm-1.4-1, libstarpu-contribrm-1.4-1t64
 Provides: ${t64:Provides}, libstarpu-anyrm-1.4-1
 Description: Task scheduler for heterogeneous multicore machines
  StarPU is a runtime system that offers support for heterogeneous

## starpu-contrib 1.4.9+dfsg

=== min-dgels/base/BLAS/WRAP/Makefile ===
TOPDIR=../..
include $(TOPDIR)/make.inc

#######################################################################
#  This is the makefile to create a wrapper for the CBLAS.
#######################################################################

all: libcblaswr.a

libcblaswr.a: cblaswr.o
	$(ARCH) $(ARCHFLAGS) libcblaswr.a cblaswr.o
	$(RANLIB) libcblaswr.a
	
libfblaswr.a: fblaswr.o
	$(ARCH) $(ARCHFLAGS) libfblaswr.a fblaswr.o
	$(RANLIB) libfblaswr.a

clean:
	rm -f *.o *.a

.c.o: 
	$(CC) $(CFLAGS) -c $*.c

=== min-dgels/base/SRC/VARIANTS/Makefile ===
TOPDIR=../..
include $(TOPDIR)/make.inc

#######################################################################
#  This is the makefile to create a the variants libraries for LAPACK.
#  The files are organized as follows:
#       CHOLRL -- Right looking block version of the algorithm, calling Level 3 BLAS
#       CHOLTOP -- Top looking block version of the algorithm, calling Level 3 BLAS
#       LUCR -- Crout Level 3 BLAS version of LU factorization
#       LULL -- left-looking Level 3 BLAS version of LU factorization
#       QRLL -- left-looking Level 3 BLAS version of QR factorization
#       LUREC -- an iterative version of Sivan Toledo's recursive LU algorithm[1].  
#       For square matrices, this iterative versions should
#       be within a factor of two of the optimum number of memory transfers.
#
# [1] Toledo, S. 1997. Locality of Reference in LU Decomposition with
#  Partial Pivoting. SIAM J. Matrix Anal. Appl. 18, 4 (Oct. 1997),
#  1065-1081. http://dx.doi.org/10.1137/S0895479896297744
#######################################################################

VARIANTSDIR=LIB

CHOLRL = cholesky/RL/cpotrf.o cholesky/RL/dpotrf.o cholesky/RL/spotrf.o cholesky/RL/zpotrf.o

CHOLTOP = cholesky/TOP/cpotrf.o cholesky/TOP/dpotrf.o cholesky/TOP/spotrf.o cholesky/TOP/zpotrf.o

LUCR = lu/CR/cgetrf.o lu/CR/dgetrf.o lu/CR/sgetrf.o lu/CR/zgetrf.o

LULL = lu/LL/cgetrf.o lu/LL/dgetrf.o lu/LL/sgetrf.o lu/LL/zgetrf.o

LUREC = lu/REC/cgetrf.o lu/REC/dgetrf.o lu/REC/sgetrf.o lu/REC/zgetrf.o

QRLL = qr/LL/cgeqrf.o qr/LL/dgeqrf.o qr/LL/sgeqrf.o qr/LL/zgeqrf.o  qr/LL/sceil.o


all: cholrl choltop lucr lull lurec qrll

cholrl: $(CHOLRL)
	$(ARCH) $(ARCHFLAGS) $(VARIANTSDIR)/cholrl.a $(CHOLRL)
	$(RANLIB) $(VARIANTSDIR)/cholrl.a

choltop: $(CHOLTOP)
	$(ARCH) $(ARCHFLAGS) $(VARIANTSDIR)/choltop.a $(CHOLTOP)
	$(RANLIB) $(VARIANTSDIR)/choltop.a

lucr: $(LUCR)
	$(ARCH) $(ARCHFLAGS) $(VARIANTSDIR)/lucr.a $(LUCR)
	$(RANLIB) $(VARIANTSDIR)/lucr.a

lull: $(LULL)
	$(ARCH) $(ARCHFLAGS) $(VARIANTSDIR)/lull.a $(LULL)
	$(RANLIB) $(VARIANTSDIR)/lull.a

lurec: $(LUREC)
	$(ARCH) $(ARCHFLAGS) $(VARIANTSDIR)/lurec.a $(LUREC)
	$(RANLIB) $(VARIANTSDIR)/lurec.a
	
qrll: $(QRLL)
	$(ARCH) $(ARCHFLAGS) $(VARIANTSDIR)/qrll.a  $(QRLL)
	$(RANLIB) $(VARIANTSDIR)/qrll.a


.c.o: 
	$(CC) $(CFLAGS) -c $< -o $@
	
clean:
	rm -f $(CHOLRL) $(CHOLTOP) $(LUCR) $(LULL) $(LUREC) $(QRLL) \
	      $(VARIANTSDIR)/*.a

=== debian/changelog ===
starpu-contrib (1.4.9+dfsg-2build1) resolute; urgency=medium

  * No-change rebuild for libomp5 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 31 Oct 2025 19:51:45 +0100

starpu-contrib (1.4.9+dfsg-2) unstable; urgency=medium

  * control: Disable rocblas and hipblas depends for now too.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 28 Oct 2025 23:35:43 +0100

starpu-contrib (1.4.9+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Rename libstarpu-1.4-7 into libstarpu-1.4-8 according to soname bump.
    - patches/hip-opencl: Upstreamed.
  * rules: Fix setting contrib dependencies.
  * copyright: Drop physical address of FSF.
  * control: Disable rocblas and hipblas build-depends for now.
  * watch: Bump version.
  * control: Turn papi whitelist into a blacklist. This enables support on
    riscv64 and loong64 (Closes: #1111435)
  * copyright: Update.

 -- Samuel Thibault <sthibault@debian.org>  Mon, 27 Oct 2025 11:46:30 +0100

starpu-contrib (1.4.8+dfsg-4) unstable; urgency=medium

  * control: Fix typo. 

 -- Samuel Thibault <sthibault@debian.org>  Fri, 15 Aug 2025 09:29:13 +0200

starpu-contrib (1.4.8+dfsg-3) unstable; urgency=medium

  * control: Add missing dependency of libstarpu-dev on hip headers.

 -- Samuel Thibault <sthibault@debian.org>  Fri, 15 Aug 2025 01:25:02 +0200

=== debian/control ===
--- 
+++ 
@@ -52,7 +52,8 @@
 	libhwloc-dev,
 	libpapi-dev [!s390x !alpha !hurd-any !m68k !powerpc !sh4 !sparc64],
 	opencl-headers, ocl-icd-opencl-dev,
-	libamdhip64-dev [amd64 arm64 ppc64el], libhipblas-dev [amd64 arm64 ppc64el], librocblas-dev [amd64 arm64 ppc64el],
+	libamdhip64-dev [amd64 arm64 ppc64el],
+#	libhipblas-dev [amd64 arm64 ppc64el], librocblas-dev [amd64 arm64 ppc64el],
 Conflicts: libstarpu-dev
 Provides: libstarpu-any-dev
 Description: Task scheduler for heterogeneous multicore machines - dev

## starpu-contrib 1.4.10%2Bdfsg

=== debian/watch ===
Version: 5

Source: https://files.inria.fr/starpu/
Matching-Pattern: (?:|.*/)starpu(?:[_\-]v?|)@ANY_VERSION@@ARCHIVE_EXT@
Dversionmangle: s/\+dfsg\d*$//
Pgpsigurlmangle: s/$/.asc/
Uversionmangle: s/(\d)(rc\d*)$/$1~$2/

## starpu-contrib 1.4.10+dfsg

=== debian/changelog ===
starpu-contrib (1.4.10+dfsg-2) unstable; urgency=medium

  * patches/doxygen-choke: Fix typos making doxygen 1.9.15 choke
    (Closes: #1121854)

 -- Samuel Thibault <sthibault@debian.org>  Thu, 04 Dec 2025 17:54:23 +0100

starpu-contrib (1.4.10+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Rename libstarpu-1.4-8 into libstarpu-1.4-9 according to soname bump.
  * patches/doxygen-hip: Avoid doxygen build warning.

 -- Samuel Thibault <sthibault@debian.org>  Wed, 03 Dec 2025 13:16:15 +0100

starpu-contrib (1.4.9+dfsg-3) unstable; urgency=medium

  * Upload for libomp transition/rename (Closes: Bug#1121396)

 -- Samuel Thibault <sthibault@debian.org>  Tue, 25 Nov 2025 20:34:00 +0100

=== debian/control ===
--- 
+++ 
@@ -27,7 +27,7 @@
 #	guile-2.2,
 	opencl-c-headers, ocl-icd-opencl-dev | opencl-dev,
 	libamdhip64-dev [amd64 arm64 ppc64el], hipcc [amd64 arm64 ppc64el],
-#	libhipblas-dev [amd64 arm64 ppc64el], librocblas-dev [amd64 arm64 ppc64el],
+#	libhipblas-dev [amd64 arm64], librocblas-dev [amd64 arm64],
 	pkg-rocm-tools,
 	gfortran,
 	help2man, doxygen,
@@ -42,7 +42,7 @@
 Package: libstarpu-contrib-dev
 Section: contrib/libdevel
 Architecture: any
-Depends: libstarpu-contrib-1.4-8 (= ${binary:Version}) | libstarpu-any-1.4-8,
+Depends: libstarpu-contrib-1.4-9 (= ${binary:Version}) | libstarpu-any-1.4-9,
 	libstarpu-contrib-openmp-llvm-1.4-1t64 (= ${binary:Version}) [amd64 arm64 armhf mips64el ppc64el riscv64 ppc64 loong64] | libstarpu-any-openmp-llvm-1.4-1 [amd64 arm64 armhf mips64el ppc64el riscv64 ppc64 loong64],
 	libstarpu-contribfft-1.4-1t64 (= ${binary:Version}) | libstarpu-anyfft-1.4-1,
 	libstarpu-contribmpi-1.4-3t64 (= ${binary:Version}) | libstarpu-anympi-1.4-3,
@@ -68,12 +68,12 @@
  This package contains development headers and libraries.
  This "contrib" version is built against CUDA.
 
-Package: libstarpu-contrib-1.4-8
-Architecture: any
-Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: libstarpu-1.4-8
-Provides: libstarpu-any-1.4-8
+Package: libstarpu-contrib-1.4-9
+Architecture: any
+Multi-Arch: same
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Conflicts: libstarpu-1.4-9
+Provides: libstarpu-any-1.4-9
 Description: Task scheduler for heterogeneous multicore machines
  StarPU is a runtime system that offers support for heterogeneous
  multicore machines. While many efforts are devoted to design efficient
